function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var reactBootstrap = require('react-bootstrap');

var PaginationPlus = function PaginationPlus(props) {
  if (typeof props.total === 'undefined' || typeof props.pageSize === 'undefined') {
    return /*#__PURE__*/React__default.createElement("p", null, "Props total and pageSize can't be empty.");
  }

  var _useState = React.useState(props.currentPage ? props.currentPage - 1 : 0),
      currentPage = _useState[0],
      setCurrentPage = _useState[1];

  var _useState2 = React.useState(props.pageSize || 10),
      pageSize = _useState2[0],
      setPageSize = _useState2[1];

  var _useState3 = React.useState([]),
      pagiItems = _useState3[0],
      setPagiItems = _useState3[1];

  var _useState4 = React.useState(null),
      goToPage = _useState4[0],
      setGoToPage = _useState4[1];

  var allPageSize = props.allPageSize ? props.allPageSize : [10, 20, 40, 80, 160];

  var _useState5 = React.useState(typeof window !== 'undefined' ? window.innerWidth < 992 : false),
      isMobile = _useState5[0],
      setIsMobile = _useState5[1];

  var _useState6 = React.useState(!isMobile ? props.size || 'md' : 'sm'),
      pagiSize = _useState6[0],
      setPagiSize = _useState6[1];

  var numOfPage = Math.ceil(props.total / props.pageSize);

  var handleChange = function handleChange(e) {
    if (typeof e.target.text !== 'undefined' && parseInt(e.target.text) - 1 !== currentPage) {
      setCurrentPage(parseInt(e.target.text) - 1);

      if (typeof props.onChange !== 'undefined') {
        props.onChange(parseInt(e.target.text));
      }
    }
  };

  if (typeof window !== 'undefined') {
    window.addEventListener('resize', function () {
      setIsMobile(window.innerWidth < 992);

      if (window.innerWidth < 992) {
        setPagiSize('sm');
      } else {
        setPagiSize(props.size);
      }
    });
  }

  var handleGoTo = function handleGoTo(e) {
    if (goToPage < numOfPage && goToPage >= 0) {
      setCurrentPage(goToPage);

      if (typeof props.onChange !== 'undefined') {
        props.onChange(goToPage + 1);
      }
    }

    e.preventDefault();
    e.stopPropagation();
  };

  var handleCustomPerPage = function handleCustomPerPage(val) {
    setCurrentPage(0);
    setPageSize(val);
    numOfPage = Math.ceil(props.total / val);
    populatePageItems();

    if (typeof props.onPageSizeChange !== 'undefined') {
      props.onPageSizeChange(val);
    }
  };

  var updateCurrentPage = function updateCurrentPage(page) {
    setCurrentPage(page);

    if (typeof props.onChange !== 'undefined') {
      props.onChange(page + 1);
    }
  };

  var populatePageItems = function populatePageItems() {
    if (numOfPage < 6) {
      setPagiItems(Array.from(Array(numOfPage), function (e, i) {
        return i;
      }));
    } else {
      if (currentPage < 3) {
        var tempPagiItems = Array.from(Array(6), function (e, i) {
          return i;
        });
        tempPagiItems.push('dotted');
        tempPagiItems.push(numOfPage - 1);
        setPagiItems(tempPagiItems);
      } else {
        var _tempPagiItems = [];

        if (currentPage - 2 > 0) {
          if (currentPage - 2 !== 0) {
            _tempPagiItems.push(0);

            if (currentPage - 3 !== 0) {
              _tempPagiItems.push('dotted');
            }
          }

          _tempPagiItems.push(currentPage - 2);
        }

        if (currentPage - 1 > 1) {
          _tempPagiItems.push(currentPage - 1);
        }

        _tempPagiItems.push(currentPage);

        if (currentPage + 1 < numOfPage) {
          _tempPagiItems.push(currentPage + 1);
        }

        if (currentPage + 2 < numOfPage) {
          _tempPagiItems.push(currentPage + 2);

          if (currentPage + 2 !== numOfPage - 1) {
            if (currentPage + 3 < numOfPage - 1) {
              _tempPagiItems.push('dotted');
            }

            _tempPagiItems.push(numOfPage - 1);
          }
        }

        setPagiItems(_tempPagiItems);
      }
    }
  };

  React.useEffect(function () {
    populatePageItems();
  }, [numOfPage, currentPage]);
  return /*#__PURE__*/React__default.createElement(reactBootstrap.Row, null, /*#__PURE__*/React__default.createElement(reactBootstrap.Col, {
    xs: 12
  }, /*#__PURE__*/React__default.createElement("div", {
    style: props.style
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "d-flex d-inline-flex",
    style: {
      marginRight: '10px',
      marginTop: '10px'
    }
  }, /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination, {
    style: {
      margin: '0'
    },
    size: pagiSize,
    className: "d-inline-flex"
  }, /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.First, {
    onClick: function onClick() {
      updateCurrentPage(0);
    }
  }), /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.Prev, {
    onClick: function onClick() {
      if (currentPage > 0) {
        updateCurrentPage(currentPage - 1);
      }
    }
  }), pagiItems.map(function (i) {
    if (i === 'dotted') {
      return /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.Item, {
        key: Math.random(),
        disabled: true
      }, "...");
    } else {
      return /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.Item, {
        key: i,
        active: i === currentPage,
        onClick: handleChange
      }, i + 1);
    }
  }), /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.Next, {
    onClick: function onClick() {
      if (currentPage < numOfPage - 1) {
        updateCurrentPage(currentPage + 1);
      }
    }
  }), /*#__PURE__*/React__default.createElement(reactBootstrap.Pagination.Last, {
    onClick: function onClick() {
      updateCurrentPage(numOfPage - 1);
    }
  }))), /*#__PURE__*/React__default.createElement("div", {
    className: "d-flex d-inline-flex",
    style: {
      marginRight: '10px',
      marginTop: '10px'
    }
  }, /*#__PURE__*/React__default.createElement(reactBootstrap.DropdownButton, {
    id: "dropdown-basic-button",
    title: pageSize + ' / Page',
    size: pagiSize,
    className: "d-inline-flex"
  }, allPageSize.map(function (ps) {
    return /*#__PURE__*/React__default.createElement(reactBootstrap.Dropdown.Item, {
      key: ps,
      eventKey: ps,
      onClick: function onClick(e) {
        handleCustomPerPage(parseInt(e.target.text));
      }
    }, ps, " / Page ");
  }))), typeof props.onPageSizeChange !== 'undefined' && /*#__PURE__*/React__default.createElement("div", {
    className: "d-flex d-inline-flex",
    style: {
      marginTop: '10px'
    }
  }, /*#__PURE__*/React__default.createElement(reactBootstrap.Form, {
    inline: true,
    onSubmit: handleGoTo,
    className: "d-inline-flex"
  }, /*#__PURE__*/React__default.createElement(reactBootstrap.Form.Control, {
    type: "number",
    id: "inlineFormInputName2",
    placeholder: currentPage + 1,
    min: 0,
    max: numOfPage,
    style: {
      width: '60px',
      marginRight: '10px'
    },
    size: pagiSize,
    onChange: function onChange(e) {
      setGoToPage(parseInt(e.target.value) - 1);
    }
  }), /*#__PURE__*/React__default.createElement(reactBootstrap.Button, {
    type: "submit",
    size: pagiSize
  }, "Go"))))));
};

var Layout = function Layout(props) {
  var _useState = React.useState(typeof window !== 'undefined' ? window.innerWidth < 992 : false),
      isMobile = _useState[0],
      setIsMobile = _useState[1];

  var showSidebar = typeof props.showSidebar !== 'undefined' ? props.showSidebar : true;
  var sidebarRef = React.useRef(null);
  var topbarRef = React.useRef(null);

  var handleClickOutside = function handleClickOutside(e) {
    if (window.innerWidth < 992 && showSidebar && typeof props.onSidebarChange !== 'undefined' && !sidebarRef.current.contains(e.target) && !topbarRef.current.contains(e.target)) {
      props.onSidebarChange(false);
    }
  };

  if (typeof window !== 'undefined') {
    window.addEventListener('resize', function () {
      setIsMobile(window.innerWidth < 992);

      if (typeof props.onSidebarChange !== 'undefined') {
        props.onSidebarChange(window.innerWidth > 992);
      }
    });
    window.addEventListener('mousedown', handleClickOutside);
    window.addEventListener('load', function () {
      if (window.innerWidth < 992) {
        if (typeof props.onSidebarChange !== 'undefined') {
          props.onSidebarChange(false);
        }
      }
    });
  }

  var contentStyle = props.contentStyle || {};
  contentStyle.paddingLeft = !isMobile && showSidebar ? props.sidebarWidth || '250px' : '0px';
  return /*#__PURE__*/React__default.createElement(React.Fragment, null, /*#__PURE__*/React__default.createElement("div", {
    style: {
      width: props.sidebarWidth || '250px',
      backgroundColor: props.sidebarBackgroundColor || 'black',
      position: 'fixed',
      height: '100%',
      zIndex: '99'
    },
    hidden: !showSidebar,
    ref: sidebarRef
  }, props.sidebar), /*#__PURE__*/React__default.createElement("div", {
    style: {
      paddingLeft: !isMobile && showSidebar ? props.sidebarWidth || '250px' : '0px'
    },
    ref: topbarRef
  }, props.topbar), /*#__PURE__*/React__default.createElement("div", {
    style: contentStyle
  }, props.content));
};

exports.Layout = Layout;
exports.PaginationPlus = PaginationPlus;
//# sourceMappingURL=index.js.map
